/*
 * GccApplication2.c
 *
 * Created: 5/13/2018 4:04:06 PM
 * Author : alexandru.sontica
 */ 

#define F_CPU 16000000
#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include <stdlib.h>
#include <string.h>
#include <stdbool.h>

#include "lcd.h"
#include "mypff.h"

FATFS fs;


/*
 * Four-Character Code - folosit pentru a indentifica formate de date
 */
#define FCC(c1, c2, c3, c4) \
	(((DWORD)(c4) << 24) + \
	 ((DWORD)(c3) << 16) + \
	 (( WORD)(c2) <<  8) + \
	 (( BYTE)(c1) <<  0))


uint8_t	buf[2][256];	// wave output buffers (double buffering)
const	 uint16_t	buf_size = 256;	// front and back buffer sizes
volatile uint8_t	buf_front = 0;	// front buffer index (current buffer used)
volatile uint8_t	buf_pos = 0;	// current buffer position
volatile uint8_t	buf_sync = 0;

#define BUF_FRONT	(buf[buf_front])
#define BUF_BACK	(buf[1 - buf_front])




/*
#define c    261
#define d    294
#define e    329
#define f    349
#define g    391
#define gS   415
#define a    440
#define aS   455
#define b    466
#define cH   523
#define cSH  554
#define dH   587
#define dSH  622
#define eH   659
#define fH   698
#define fSH  740
#define gH   784
#define gSH  830
#define aH   880

uint16_t surprise_notes[] = {a, a, a, f, cH, a, f, cH, a, eH, eH, eH, fH, cH, gS, f, cH, a, aH, a, a, aH, gSH, gH, fSH, fH, fSH, aS, dSH, dH, cSH, cH, b, cH, f, gS, f, a, cH, a, cH, eH, aH, a, a, aH, gSH, gH, fSH, fH, fSH, aS, dSH, dH, cSH, cH, b, cH, f, gS, f, cH, a, f, cH, a};

uint16_t durations[] = {500, 500, 500, 350, 150, 500, 350, 150, 650, 500, 500, 500, 350, 150, 500, 350, 150, 650, 500, 300, 150, 400, 200, 200, 125, 125, 250, 250, 400, 200, 200, 125, 125, 250, 125, 500, 375, 125, 500, 375, 125, 650, 500, 300, 150, 400, 200, 200, 125, 125, 250, 250, 400, 200, 200, 125, 125, 250, 250, 500, 375, 125, 500, 375, 125, 650};

uint8_t num_notes = sizeof(durations) / sizeof(durations[0]);







int nr_nota = 0;
int durata;
int stop = 0;
int old_ocr1a;
void update_song()
{
	if (stop)
		return;
	
	durata -= 25;
	if (durata < 25) {
		OCR1A = 15625 / surprise_notes[nr_nota];
		OCR1B = OCR1A/2;
		TCNT1 = 0;
		durata = durations[nr_nota];
		nr_nota = (nr_nota+1)%64;
	}
}

void timer1_init()
{
	// fast pwm cu TOP la OCR1A
	TCCR1A |= (3 << WGM10);
	TCCR1B |= (3 << WGM12);
	
	// prescaler 1024
	TCCR1B |= (5 << CS10);
	
	// pwm pe oc1b, non inverting, pe PD4
	TCCR1A |= (1 << COM1B1);
	TCCR1A &= ~(1 << COM1B0);
}*/

void adc_init()
{
	ADMUX |= (1 << MUX0);          // ADC1 - channel 1
	ADMUX |= (1 << REFS0);         // AVCC with external capacitor at AREF pin

	ADCSRA |= (1 << ADPS2) | (1 << ADPS1) | (1 << ADPS0); //set clock prescaler at 128
	ADCSRA |= (1 << ADEN);         // enable ADC
}

static int cnt;
ISR(PCINT3_vect)
{
	if ((PIND & (1 << PD6)) == 0) {
		/* porneste si opreste muzica cu darth vader
		stop = 1 - stop;
		if (stop) {
			old_ocr1a = OCR1A;
			OCR1A = 0;
		} else {
			OCR1A = old_ocr1a;
			old_ocr1a = 0;
		}
		*/
		LCD_printAt(0, "                ");
		LCD_printAt(0x40, "                ");
		
		//start conversion
		ADCSRA |= (1 << ADSC);
		
		//wait until conversion is done: until ADSC from ADCSRA is set to 0
		while(ADCSRA & (1 << ADSC));
		
		unsigned int value = ADC;
		unsigned int threshold = (PINB & (1 << PB1));
		threshold = !threshold;

		
		char string[10];
		itoa(value, string, 10);
		
		
		cnt++;
		char aux[10];
		itoa(cnt, aux, 10);
		
		char thr[2];
		thr[0] = '0' + threshold;
		thr[1] = '\0';
		
		LCD_printAt(0, aux);
		LCD_printAt(0x40, string);
		LCD_printAt(0x45, thr);

		_delay_ms(500);
		
	}	
}

ISR(TIMER0_COMPA_vect)
{
	OCR1B = BUF_FRONT[buf_pos++];

	// swap buffers when end is reached (end is 256 <=> overflow to 0)
	if(buf_pos == 0)
	buf_front = 1 - buf_front;
}

void timer0_start(void)
{
	// interrupt on compare A
	TIMSK0 |= (1 << OCIE0A);
	// CTC, top OCRA
	TCCR0B |= (0 << WGM02);
	TCCR0A |= (1 << WGM01) | (0 << WGM00);
	// prescaler 8
	TCCR0B |= (2 << CS00);
}

void timer0_stop(void)
{
	TCCR0B = 0;
	TCCR0A = 0;
	TIMSK0 = 0;
	OCR0A = 0;
	TCNT0 = 0;
}


void timer1_start(void)
{
	// 8-bit FastPWM
	TCCR1B |= (1 << WGM12);
	TCCR1A |= (1 << WGM10);
	// channel B inverted
	TCCR1A |= (1 << COM1B0) | (1 << COM1B1);
	// prescaler 1
	TCCR1B |= (1 << CS10);
}

void timer1_stop(void)
{
	TCCR1B = 0;
	TCCR1A = 0;
	OCR1B = 0;
	TCNT1 = 0;
}


bool continue_play()
{
	if((PINB & (1 << PB2)) == 0 && (PIND & (1 << PD6)) == 0)
		return false;

	return true;
}

/*
 * Incarca header-ul unui fisier WAVE
 *
 * @return DWORD
 * 	0 => format invalid
 * 	1 => eroare I/O
 * 	>1 => numarul de sample-uri
 */
DWORD load_header(void)
{
	DWORD size;
	WORD ret;

	// citeste header-ul (12 octeti)
	if(pf_read(BUF_FRONT, 12, &ret))
		return 1;

	if(ret != 12 || LD_DWORD(BUF_FRONT + 8) != FCC('W','A','V','E'))
		return 0;

	for(;;)
	{
		// citeste chunk ID si size
		pf_read(BUF_FRONT, 8, &ret);
		if(ret != 8)
			return 0;

		size = LD_DWORD(&BUF_FRONT[4]);

		// verifica FCC
		switch(LD_DWORD(&BUF_FRONT[0]))
		{
			// 'fmt ' chunk
			case FCC('f','m','t',' '):
				// verifica size
				if(size > 100 || size < 16) return 0;

				// citeste continutul
				pf_read(BUF_FRONT, size, &ret);
				// verifica codificarea
				if(ret != size || BUF_FRONT[0] != 1) return 0;
				// verifica numarul de canale
				if(BUF_FRONT[2] != 1 && BUF_FRONT[2] != 2) return 0;
				// verifica rezolutia
				if(BUF_FRONT[14] != 8 && BUF_FRONT[14] != 16) return 0;

				// seteaza sampling rate-ul
				OCR0A = (BYTE)(F_CPU / 8 / LD_WORD(&BUF_FRONT[4])) - 1;
				break;

			// 'data' chunk => incepe redarea
			case FCC('d','a','t','a'):
				return size;

			// 'LIST' chunk => skip
			case FCC('L','I','S','T'):
			// 'fact' chunk => skip
			case FCC('f','a','c','t'):
				pf_lseek(fs.fptr + size);
				break;

			// chunk necunoscut => eroare
			default:
				return 0;
		}
	}

	return 0;
}

/*
 * Functie care reda un fisier audio
 *
 * path - calea absoluta a fisierului
 *
 * @return UINT
 *	FR_OK daca a rulat cu succes fisierul
 */
UINT play(const char *path)
{
	FRESULT ret;

	if((ret = pf_open(path)) == FR_OK)
	{
		WORD bytes_read;

		// incarca header-ul fisierului
		DWORD current_size = load_header();
		if(current_size < buf_size)
			return FR_NO_FILE;

		// align to sector boundary
		ret = pf_lseek((fs.fptr + 511) & ~511);
		if(ret != FR_OK)
			return ret;

		// fill front buffer
		ret = pf_read(BUF_FRONT, buf_size, &bytes_read);
		if(ret != FR_OK)
			return ret;
		if(bytes_read < buf_size)
			return ret;

		// reset front buffer index
		buf_pos = 0;

		// start output
		timer0_start();
		timer1_start();
		DDRD |= (1 << PD4);

		while(continue_play())
		{
			uint8_t old_buf_front = buf_front;
			
			// fill back buffer
			ret = pf_read(BUF_BACK, buf_size, &bytes_read);
			if(ret != FR_OK)
				break;
			if(bytes_read < buf_size)
				break;

			// wait for buffer swap
			while(old_buf_front == buf_front) ;
		}

		// stop output
		DDRD &= ~(1 << PD4);
		timer1_stop();
		timer0_stop();
	}

	return ret;
}

int main(void)
{
	sei();
	PCICR |= (1 << PCIE3);
	PCMSK3 |= (1 << PCINT30);
		
	/* initializam timer1 pt a-l folosi cu fastPWM pt speaker */
	//timer1_init();
	
	
	/* ledul de langa cel de POWER */
	DDRD |= (1 << PD7);
	
	/* buzzerul */
	DDRD |= (1 << PD4);
	PORTD &= ~(1 << PD4);
	
	/* initializare lcd */
	LCD_init();
	
	/* aprindem ledul lcd-ului */
	DDRC |= (1 << PC2);
	PORTC |= (1 << PC2);
	
	/* configurare PA1 ca ADC pt masuratoare senzor MQ3 */
	adc_init();
	
	/* configurare PB1 ca input pt threshold senzor MQ3 */
	DDRB &= ~(1 << PB1);
	PORTB &= ~(1 << PB1);
	
	
	/* Replace with your application code */
	for(;;)
	{
		// mount filesystem
		LCD_printAt(0x00, "mounting...");

		if(pf_mount(&fs) != FR_OK)
		{
			// wait a while and retry
			_delay_ms(1000);
			continue;
		}
		
		LCD_printAt(0x00, "                ");
		LCD_printAt(0x00, "mounted!");
		_delay_ms(1000);
		
		
		// play("MUZICA/TROSCOTEL.WAV");
		FRESULT ret;
		DIR dir;
		FILINFO fil;

		ret = pf_opendir(&dir, "MUZICA");
		if(ret == FR_OK) {
			LCD_printAt(0x40, "Da 2");
			
			pf_readdir(&dir, &fil);
			LCD_printAt(0x00, "                ");
			LCD_printAt(0x00, fil.fname);
			
			// play("MUZICA/POL.WAV");
		} else {
			LCD_printAt(0x40, "Nu 2");
		}
		for (;;) {
			
		}
		
	}
	return 0;
}

